/* Rounds to the nearest (long int) integer

   Copyright (C) 2006 IBM Corporation.
   Copyright (C) 2007-2018 Free Software Foundation, Inc.

   This file is part of the Decimal Floating Point C Library.

   Author(s): Joseph Kerian <jkerian@us.ibm.com>

   The Decimal Floating Point C Library is free software; you can
   redistribute it and/or modify it under the terms of the GNU Lesser
   General Public License version 2.1.

   The Decimal Floating Point C Library is distributed in the hope that
   it will be useful, but WITHOUT ANY WARRANTY; without even the implied
   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
   the GNU Lesser General Public License version 2.1 for more details.

   You should have received a copy of the GNU Lesser General Public
   License version 2.1 along with the Decimal Floating Point C Library;
   if not, write to the Free Software Foundation, Inc., 59 Temple Place,
   Suite 330, Boston, MA 02111-1307 USA.

   Please see libdfp/COPYING.txt for more information.  */

#ifndef _DECIMAL_SIZE
#  define _DECIMAL_SIZE 32
#  include <decimal32.h>
#endif

#include <math.h>
#include <fenv.h>

#define FUNCTION_NAME lrint
#define __ROUND_RETURN_TYPE	long int
#define __MIN_VALUE	LONG_MIN
#define __MAX_VALUE	LONG_MAX
#include <mapround.h>
#define __ROUND_MODE	__dn_getround()

#define POSTFIX_CHECK					\
  do							\
    {							\
      if (x != result)					\
	{						\
	  DFP_EXCEPT (FE_INEXACT);			\
	}						\
    } while (0)

#include "llroundd32.c"
